---
title: metadata
type: condition
status: deprecated
---

<!--
     THIS FILE IS AUTOGENERATED!

     To make changes please edit the contents of:
     lib/condition/metadata.go
-->

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';

:::warning DEPRECATED
This component is deprecated and will be removed in the next major version release. Please consider moving onto [alternative components](#alternatives).
:::


<Tabs defaultValue="common" values={[
  { label: 'Common', value: 'common', },
  { label: 'Advanced', value: 'advanced', },
]}>

<TabItem value="common">

```yaml
# Common config fields, showing default values
metadata:
  operator: equals_cs
  key: ""
  arg: ""
```

</TabItem>
<TabItem value="advanced">

```yaml
# All config fields, showing default values
metadata:
  operator: equals_cs
  key: ""
  arg: ""
  part: 0
```

</TabItem>
</Tabs>

## Fields

### `operator`

An [operator](#operators) to apply.


Type: `string`  
Default: `"equals_cs"`  

### `key`

The key of the metadata field to check.


Type: `string`  
Default: `""`  

### `arg`

An argument to check against. For some operators this field not be required.


Type: `string`  
Default: `""`  

### `part`

The index of a message within a batch to test the condition against. This
field is only applicable when batching messages
[at the input level](/docs/configuration/batching).

Indexes can be negative, and if so the part will be selected from the end
counting backwards starting from -1.


Type: `number`  
Default: `0`  

## Alternatives

Consider using the [bloblang](/docs/components/conditions/bloblang) condition
instead as it offers a wide range of metadata processing options. For example,
the following condition:

``` yaml
metadata:
  operator: enum
  key: foo
  arg:
    - bar
    - baz
    - qux
    - quux
```

Can instead be expressed with:

``` yaml
bloblang: '["bar","baz","qux","quux"].contains(meta("foo"))'
```

