---
title: resource
type: condition
status: stable
---

<!--
     THIS FILE IS AUTOGENERATED!

     To make changes please edit the contents of:
     lib/condition/resource.go
-->

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';


Runs a condition resource by its name. This condition allows you to run the same
configured condition resource in multiple processors, or as a branch of another
condition.

```yaml
# Config fields, showing default values
resource: ""
```

## Examples

Let's imagine we have two outputs, one of which only receives messages that
satisfy a condition and the other receives the logical NOT of that same
condition. In this example we can save ourselves the trouble of configuring the
same condition twice by referring to it as a resource, like this:

``` yaml
output:
  broker:
    pattern: fan_out
    outputs:
      - type: foo
        processors:
        - filter:
            resource: foobar
      - type: bar
        processors:
        - filter:
            not:
              resource: foobar
resources:
  conditions:
    foobar:
      bloblang: 'this.from(1) == "filter me please"'
```

